;*******************************************
;PROGRAMOVATELN INTERFACE STROJE - ZKUEBN
;KOLEN MEFI 2003 (dual)
;Definice maker (uivatelskch instrukc)
;*******************************************

CONTROL_T_MACRO pos

;.......

;Definice uivatelsk instrukce LOD1, kter provd
;podmnn ten buky do DR v ppad, e RLO je 1.
DEF_T_MACRO LOD1 p1
T_LOCAL	END_LOD1

	JL0		END_LOD1
	LOD		TMAC.p1
END_LOD1:

END_T_MACRO T_NORMAL, C_0, D_ON


;.......

;Definice uivatelsk instrukce EDGESET, kter testuje
;signl Sig a pi nbn hran nastav Mech na 1.
DEF_T_MACRO EDGESET Sig, Mech
	T_LOCAL LocData, SigMin, b2, b3, b4, b5, b6, b7, b8
	DATA_LOCAL
		LocData:	DFM SigMin, b2, b3, b4, b5, b6, b7, b8
	DATA_LOCAL_END

	LDR		tmac.Sig		;test hrany signalu
	LA		-SigMin
	FL1		1,tmac.Mech		;aktivace mechanizmu RETEZ1
	LDR		tmac.Sig
	WR		SigMin

END_T_MACRO t_normal, c_0, d_on

;.......

;Definice uivatelsk instrukce EDGEINV, kter testuje
;signl Sig a pi nbn hran RLO invertuje bit Par
DEF_T_MACRO EDGEINV  Par
	T_LOCAL LocData, SigMin, Sig, b3, b4, b5, b6, b7, b8
	T_LOCAL NavMac
	DATA_LOCAL
		LocData:	DFM SigMin, Sig, b3, b4, b5, b6, b7, b8
	DATA_LOCAL_END

	WR		Sig			;test hrany signalu
	LA		-SigMin
	JL0		NavMac
	LDR		-tmac.Par
	WR		tmac.Par
NavMac:
	LDR		Sig
	WR		SigMin

END_T_MACRO t_normal, c_0, d_on

;........


;Definice uivatelsk instrukce LODQ, kter
;naete bunku velkosti QWORD.
DEF_T_MACRO LODQ p1
	MOV	EAX,DWORD PTR p1
	MOV	EDX,DWORD PTR p1+4
END_T_MACRO T_NORMAL, C_0, D_ON

;.......

;Definice uivatelsk instrukce STOQ, kter
;yape bunku velkosti QWORD.
DEF_T_MACRO STOQ p1
	MOV	DWORD PTR p1,EAX
	MOV	DWORD PTR p1+4,EDX
END_T_MACRO T_NORMAL, C_0, D_ON

;.......

;Definice uivatelsk instrukce LODQMM, kter nate do datovho
;registru mru v mikrometrech z QWORDu (kde je mra v 1/64536)
DEF_T_MACRO LODQMM p1
	CLI
	MOV		EAX,DWORD PTR p1
	MOV		EDX,DWORD PTR p1+4
	STI
	SHRD 	EAX,EDX,16
	MOV		ECX,EAX
END_T_MACRO T_NORMAL, C_0, D_ON

;.......


;Definice uivatelsk instrukce CMPQ, kter
;porovnva bunky velkosti QWORD.
DEF_T_MACRO CMPQ p1
Local C?CMPE
T_LOCAL C?CMPE
	CMP	EDX,DWORD PTR p1+4
	JNZ	C?CMPE
	CMP	EAX,DWORD PTR p1
C?CMPE:
END_T_MACRO T_NORMAL, C_0, D_ON


;.......

;Definice uivatelsk instrukce CONVQ, kter
;poevede DR registr na QWORD.
DEF_T_MACRO CONVQ
	MOV	EAX,ECX
	CDQ	
END_T_MACRO T_NORMAL, C_0, D_ON


;........

;Prevod casu [s] z REAL do DWORD v taktu [20ms]
DEF_T_MACRO REAL_TIME20MS B_REAL,B_DWORD
		cli
		finit
		fld		qword ptr B_REAL
		fimul	word ptr BW50
		fistp	dword ptr B_DWORD
		sti  
END_T_MACRO t_normal, c_0, d_on

;........

;Prevod casu [s] z REAL do DWORD v taktu [0.1ms]
DEF_T_MACRO REAL_TIME100MS B_REAL,B_DWORD
		cli
		finit
		fld		qword ptr B_REAL
		fimul	word ptr BW10
		fistp	dword ptr B_DWORD
		sti  
END_T_MACRO t_normal, c_0, d_on

;........

;Prevod casu [0.1s] z DWORD do REAL v taktu [s]
DEF_T_MACRO DWORD_TIME1S B_DWORD,B_REAL
		cli
		finit
		fild	dword ptr B_DWORD
		fidiv	word ptr BW10
		fstp	qword ptr B_REAL
		sti  
END_T_MACRO t_normal, c_0, d_on


;........

;Prevod z REAL do DWORD primo
DEF_T_MACRO REAL_DWORD B_REAL,B_DWORD
		cli
		finit
		fld		qword ptr B_REAL
		fistp	dword ptr B_DWORD
		sti  
END_T_MACRO t_normal, c_0, d_on

;........

;Prevod z DWORD do REAL primo
DEF_T_MACRO DWORD_REAL B_DWORD,B_REAL
		cli
		finit
		fild	dword ptr B_DWORD
		fstp	qword ptr B_REAL
		sti  
END_T_MACRO t_normal, c_0, d_on


;........

;Prevod miry [mm] z REAL do DWORD na [um]
DEF_T_MACRO REAL_MM B_REAL,B_WORD
		cli
		finit
		fld		qword ptr B_REAL
		fimul	word ptr BW1000
		fistp	dword ptr B_WORD
		sti  
END_T_MACRO t_normal, c_0, d_on

;........

;Prevod rychlosti [mm/min] z REAL do DWORD na [1/64000 mm/min (POS)]
DEF_T_MACRO REAL_MM_MIN_64 B_REAL,B_WORD
		cli
		finit
		fld		qword ptr B_REAL
		fistp	word ptr B_WORD+2
		sti  
END_T_MACRO t_normal, c_0, d_on

;........

;Prevod WORD na DWORD se znamenkovym rozsirenim
DEF_T_MACRO DWORD_SIG
			MOV		AX,CX				;!! ASM znamenkove rozsireni
			CWDE						;!! prevod na DWORD
			MOV		ECX,EAX				;!!
END_T_MACRO t_normal, c_0, d_on



			

